############################################################################
#                                                                          #
#  Copyright (c) 2001, 2025 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXNodeError::BEGIN{package NXNodeError;no warnings;require NXMsg;do{
"\x4e\x58\x4d\x73\x67"->import};}package NXNodeError;no warnings;(
@__errorNamesFromDroppedNodes=());sub translationTheMessageReceivedFromNode{(my $line
=shift (@_));(my $newMessage=(""));Logger::debug3 (((
"\x74\x72\x61\x6e\x73\x6c\x61\x74\x69\x6f\x6e\x54\x68\x65\x4d\x65\x73\x73\x61\x67\x65\x52\x65\x63\x65\x69\x76\x65\x64\x46\x72\x6f\x6d\x4e\x6f\x64\x65\x20\x63\x68\x65\x63\x6b\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$line)."\x27\x2e"));if (($line=~ /Unencrypted sessions are not allowed on this node/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x55\x6e\x65\x6e\x63\x72\x79\x70\x74\x65\x64\x53\x65\x73\x73\x69\x6f\x6e\x73\x41\x72\x65\x4e\x6f\x74\x41\x6c\x6c\x6f\x77\x65\x64\x4f\x6e\x54\x68\x69\x73\x4e\x6f\x64\x65"
));return ($newMessage);}elsif (($line=~ /Session '(.*)' not allowed on this node/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x53\x65\x73\x73\x69\x6f\x6e\x4e\x6f\x74\x41\x6c\x6c\x6f\x77\x65\x64\x4f\x6e\x54\x68\x69\x73\x4e\x6f\x64\x65"
,$1));return ($newMessage);}elsif (($line=~ /On Windows platforms it is possible to connect only to physical display/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x4f\x6e\x57\x69\x6e\x4f\x6e\x6c\x79\x50\x68\x79\x73\x69\x63\x61\x6c\x44\x65\x73\x6b\x74\x6f\x70\x41\x76\x61\x69\x6c\x61\x62\x6c\x65"
));return ($newMessage);}elsif (($line=~ /On Mac platforms it is possible to connect only to physical display/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x4f\x6e\x4d\x61\x63\x4f\x6e\x6c\x79\x50\x68\x79\x73\x69\x63\x61\x6c\x44\x65\x73\x6b\x74\x6f\x70\x41\x76\x61\x69\x6c\x61\x62\x6c\x65"
));return ($newMessage);}elsif (($line=~ /XDMCP host parameter is missing/ )){(
$newMessage=Common::NXMsg::get_text (
"\x65\x47\x55\x49\x58\x64\x6d\x63\x70\x48\x6f\x73\x74\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x4d\x69\x73\x73\x69\x6e\x67"
));return ($newMessage);}elsif (($line=~ /XDMCP host parameter is invalid: (.*)\./ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x47\x55\x49\x58\x64\x6d\x63\x70\x48\x6f\x73\x74\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x49\x6e\x76\x61\x6c\x69\x64"
,$1));return ($newMessage);}elsif (($line=~ /XDMCP host parameter is null/ )){(
$newMessage=Common::NXMsg::get_text (
"\x65\x47\x55\x49\x58\x64\x6d\x63\x70\x48\x6f\x73\x74\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x49\x73\x4e\x75\x6c\x6c"
));return ($newMessage);}elsif (($line=~ /Cannot create the session. System error is: (.*)/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x54\x68\x65\x53\x65\x73\x73\x69\x6f\x6e\x53\x79\x73\x74\x65\x6d\x45\x72\x72\x6f\x72\x49\x73"
,$1));return ($newMessage);}elsif (($line=~ /Cannot start session for unknown user/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x53\x65\x73\x73\x69\x6f\x6e\x46\x6f\x72\x55\x6e\x6b\x6e\x6f\x77\x6e\x55\x73\x65\x72"
));return ($newMessage);}elsif (($line=~ /Cannot start session for user (.*) which does not exist/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x53\x65\x73\x73\x69\x6f\x6e\x46\x6f\x72\x55\x73\x65\x72\x57\x68\x69\x63\x68\x4e\x6f\x74\x45\x78\x69\x73\x74"
,$1));return ($newMessage);}elsif (($line=~ /Cannot create working directory '(.*)', '(.*)'/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x57\x6f\x72\x6b\x69\x6e\x67\x44\x69\x72\x65\x63\x74\x6f\x72\x79"
,$1,$2));return ($newMessage);}elsif (($line=~ /Cannot connect to the agent, missing display argument/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x6e\x65\x63\x74\x54\x6f\x54\x68\x65\x41\x67\x65\x6e\x74\x4d\x69\x73\x73\x69\x6e\x67\x44\x69\x73\x70\x6c\x61\x79\x41\x72\x67\x75\x6d\x65\x6e\x74"
));return ($newMessage);}elsif (($line=~ /Cannot kill session: missing session id in parameters/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x4b\x69\x6c\x6c\x53\x65\x73\x73\x69\x6f\x6e"
));return ($newMessage);}elsif (($line=~ /Timeout connecting to the requested display/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x54\x69\x6d\x65\x6f\x75\x74\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6e\x67\x54\x6f\x54\x68\x65\x52\x65\x71\x75\x65\x73\x74\x65\x64\x44\x69\x73\x70\x6c\x61\x79"
));return ($newMessage);}elsif (($line=~ /Could not create NXConsole: (.*)/ )){(
$newMessage=Common::NXMsg::get_text (
"\x65\x47\x55\x49\x43\x6f\x75\x6c\x64\x4e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x58\x43\x6f\x6e\x73\x6f\x6c\x65"
,$1));return ($newMessage);}elsif (($line=~ /Could not create NXConsole/ )){(
$newMessage=Common::NXMsg::get_text (
"\x65\x47\x55\x49\x43\x6f\x75\x6c\x64\x4e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x58\x43\x6f\x6e\x73\x6f\x6c\x65\x57\x69\x74\x68\x6f\x75\x74\x52\x65\x61\x73\x6f\x6e"
));return ($newMessage);}elsif (($line=~ /Could not get console path: (.*)/ )){(
$newMessage=Common::NXMsg::get_text (
"\x65\x43\x6f\x75\x6c\x64\x4e\x6f\x74\x47\x65\x74\x43\x6f\x6e\x73\x6f\x6c\x65\x50\x61\x74\x68"
,$1));return ($newMessage);}elsif (($line=~ /Parameter 'session type' has invalid value: (.*)/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x53\x65\x73\x73\x69\x6f\x6e\x54\x79\x70\x65\x49\x6e\x76\x61\x6c\x69\x64\x56\x61\x6c\x75\x65"
,$1));return ($newMessage);}elsif (($line=~ /Cannot create session directory: (.*)/ )
){(my $middleMessage=$1);if (($middleMessage=~ /(.*) Error is: (.*)/ )){(
$newMessage=Common::NXMsg::get_text (
"\x65\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x53\x65\x73\x73\x69\x6f\x6e\x44\x69\x72\x65\x63\x74\x6f\x72\x79\x57\x69\x74\x68\x53\x79\x73\x74\x65\x6d\x45\x72\x72\x6f\x72"
,$1,$2));return ($newMessage);}elsif (($middleMessage=~ /(.*) You do not have permission to write/ )
){($newMessage=NXMsg::get_text (
"\x65\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x53\x65\x73\x73\x69\x6f\x6e\x44\x69\x72\x65\x63\x74\x6f\x72\x79\x57\x69\x74\x68\x6f\x75\x74\x53\x79\x73\x74\x65\x6d\x45\x72\x72\x6f\x72"
,"\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72",$1));return ($newMessage);}}
elsif (($line=~ /Cannot create directory: (.*)/ )){(my $middleMessage=$1);if ((
$middleMessage=~ /(.*) Error is: (.*)/ )){($newMessage=Common::NXMsg::get_text (
"\x65\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x44\x69\x72\x65\x63\x74\x6f\x72\x79\x57\x69\x74\x68\x53\x79\x73\x74\x65\x6d\x45\x72\x72\x6f\x72"
,$1,$2));return ($newMessage);}else{($newMessage=NXMsg::get_text (
"\x65\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x44\x69\x72\x65\x63\x74\x6f\x72\x79\x57\x69\x74\x68\x6f\x75\x74\x53\x79\x73\x74\x65\x6d\x45\x72\x72\x6f\x72"
,"\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72",$middleMessage));return (
$newMessage);}}elsif (($line=~ /Start of nxrunner failed with error code: (.*)/ )
){($newMessage=Common::NXMsg::get_text (
"\x65\x53\x74\x61\x72\x74\x4f\x66\x4e\x78\x63\x6c\x69\x65\x6e\x74\x46\x61\x69\x6c\x65\x64\x57\x69\x74\x68\x45\x72\x72\x6f\x72\x43\x6f\x64\x65"
,$1));return ($newMessage);}elsif (($line=~ /Cannot write to (.*) file in (.*) on the local host\. (.*)$/ )
){(my $firstParameter=$1);(my $secondParameter=$2);(my $lastParameter=$3);if ((
$lastParameter=~ /Please verify permission attributes for that file./ )){(
$newMessage=Common::NXMsg::get_text (
"\x65\x43\x61\x6e\x6e\x6f\x74\x57\x72\x69\x74\x65\x54\x6f\x46\x69\x6c\x65\x4f\x6e\x54\x68\x65\x4c\x6f\x63\x61\x6c\x48\x6f\x73\x74\x56\x65\x72\x69\x66\x79\x50\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e"
,$firstParameter,$secondParameter));}else{($newMessage=Common::NXMsg::get_text (
"\x65\x43\x61\x6e\x6e\x6f\x74\x57\x72\x69\x74\x65\x54\x6f\x46\x69\x6c\x65\x4f\x6e\x54\x68\x65\x4c\x6f\x63\x61\x6c\x48\x6f\x73\x74"
,$firstParameter,$secondParameter,$lastParameter));}return ($newMessage);}elsif 
(($line=~ /application terminated prematurely/ )){($newMessage=
Common::NXMsg::get_text (
"\x65\x41\x70\x70\x6c\x69\x63\x61\x74\x69\x6f\x6e\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x64\x54\x6f\x6f\x45\x61\x72\x6c\x79"
));return ($newMessage);}Logger::debug3 (
"\x74\x72\x61\x6e\x73\x6c\x61\x74\x69\x6f\x6e\x54\x68\x65\x4d\x65\x73\x73\x61\x67\x65\x52\x65\x63\x65\x69\x76\x65\x64\x46\x72\x6f\x6d\x4e\x6f\x64\x65\x20\x73\x65\x6e\x64\x20\x6e\x6f\x74\x20\x74\x72\x61\x6e\x73\x6c\x61\x74\x65\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x2e"
);return ($line);}sub saveErrorNameFromDroppedNode{(my $errorName=shift (@_));
push (@__errorNamesFromDroppedNodes,$errorName);}sub 
allErrorNamesFromDroppedNodesAreSameAndKnown{for ((my $i=(0x1d9f+ 1958-0x2545));
($i<scalar (@__errorNamesFromDroppedNodes));(++$i)){if (((
$__errorNamesFromDroppedNodes[$i]eq "\x75\x6e\x6b\x6e\x6f\x77\x6e")or (
$__errorNamesFromDroppedNodes[$i]ne $__errorNamesFromDroppedNodes[
(0x0490+ 4188-0x14ec)]))){return ((0x1dca+ 2058-0x25d4));}}return (
(0x0b46+ 4954-0x1e9f));}sub getErrorNameFromFirstDroppedNode{return (
$__errorNamesFromDroppedNodes[(0x2361+ 732-0x263d)]);}sub reportSavedNodeError{(my $errorName
=getErrorNameFromFirstDroppedNode ());if ((
allErrorNamesFromDroppedNodesAreSameAndKnown ()and $errorName)){NXMsg::error (
$errorName,"\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72");}else{NXMsg::error (
"\x65\x53\x65\x73\x73\x69\x6f\x6e\x54\x79\x70\x65\x4e\x6f\x74\x41\x76\x61\x69\x6c\x61\x62\x6c\x65"
,"\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72");}}NXMsg::register_error (
"\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72",
"\x65\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x53\x65\x73\x73\x69\x6f\x6e\x44\x69\x72\x65\x63\x74\x6f\x72\x79\x57\x69\x74\x68\x6f\x75\x74\x53\x79\x73\x74\x65\x6d\x45\x72\x72\x6f\x72"
,(0x0f1a+ 2693-0x1749));NXMsg::register_error (
"\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72",
"\x65\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x44\x69\x72\x65\x63\x74\x6f\x72\x79\x57\x69\x74\x68\x6f\x75\x74\x53\x79\x73\x74\x65\x6d\x45\x72\x72\x6f\x72"
,(0x1739+ 4634-0x26fd));NXMsg::register_error (
"\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72",
"\x65\x4e\x6f\x41\x76\x61\x69\x6c\x61\x62\x6c\x65\x4e\x6f\x64\x65\x73",
(0x12c7+ 5439-0x2612));NXMsg::register_error (
"\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72",
"\x65\x4e\x6f\x46\x72\x65\x65\x44\x69\x73\x70\x6c\x61\x79",(0x03d4+ 6825-0x1c25)
);NXMsg::register_error ("\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72",
"\x65\x53\x65\x73\x73\x69\x6f\x6e\x54\x79\x70\x65\x4e\x6f\x74\x41\x76\x61\x69\x6c\x61\x62\x6c\x65"
,(0x17d5+  17-0x15f2));NXMsg::register_error (
"\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72",
"\x65\x4e\x6f\x64\x65\x73\x41\x72\x65\x44\x69\x73\x61\x62\x6c\x65\x64",
(0x02ef+ 4805-0x13c0));NXMsg::register_error (
"\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72",
"\x65\x4d\x61\x78\x69\x6d\x75\x6d\x4e\x75\x6d\x62\x65\x72\x56\x69\x72\x74\x75\x61\x6c\x53\x65\x73\x73\x69\x6f\x6e\x73\x4f\x6e\x41\x6c\x6c\x4e\x6f\x64\x65\x73"
,(0x04e7+ 4035-0x1253));NXMsg::register_error (
"\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72",
"\x65\x50\x75\x62\x6c\x69\x63\x4b\x65\x79\x4e\x6f\x74\x46\x6f\x75\x6e\x64",
(0x056b+ 3798-0x1234));NXMsg::register_error (
"\x4e\x58\x4e\x6f\x64\x65\x45\x72\x72\x6f\x72",
"\x65\x4d\x69\x73\x73\x69\x6e\x67\x53\x65\x73\x73\x69\x6f\x6e\x54\x79\x70\x65",
(0x112b+ 1852-0x1673));return ((0x1afd+ 1876-0x2250));
